/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.vorgang.vorgang;

import java.util.UUID;

import de.ozgcloud.vorgang.common.grpc.GrpcSubFormTestFactory;

public class GrpcEingangTestFactory {

	public static final String ID = UUID.randomUUID().toString();
	public static final GrpcSubForm SUB_FORM = GrpcSubFormTestFactory.create();

	public static GrpcEingang create() {
		return createBuilder().build();
	}

	public static GrpcEingang.Builder createBuilder() {
		return GrpcEingang.newBuilder()
				.setId(ID)
				.setHeader(GrpcEingangHeaderTestFactory.create())
				.setAntragsteller(GrpcAntragstellerTestFactory.create())
				.setZustaendigeStelle(GrpcZustaendigeStelleTestFactory.create())
				.setFormData(GrpcFormData.newBuilder().addForm(GrpcSubFormTestFactory.create()).build())
				.addAttachments(GrpcIncomingFileGroupTestFactory.create())
				.setNumberOfAttachments(4)
				.addRepresentations(GrpcIncomingFileTestFactory.create())
				.setNumberOfRepresentations(5);
	}
}